#[doc = "Register `PUMP_CTRL` reader"]
pub struct R(crate::R<PUMP_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PUMP_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PUMP_CTRL_SPEC>> for R {
    fn from(reader: crate::R<PUMP_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PUMP_CTRL` writer"]
pub struct W(crate::W<PUMP_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PUMP_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PUMP_CTRL_SPEC>> for W {
    fn from(writer: crate::W<PUMP_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `CLOCK_SEL` reader - Clock select: 0=external clock, 1=internal clock (deprecated)."]
pub struct CLOCK_SEL_R(crate::FieldReader<bool, bool>);
impl CLOCK_SEL_R {
    pub(crate) fn new(bits: bool) -> Self {
        CLOCK_SEL_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for CLOCK_SEL_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CLOCK_SEL` writer - Clock select: 0=external clock, 1=internal clock (deprecated)."]
pub struct CLOCK_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> CLOCK_SEL_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
        self.w
    }
}
#[doc = "Field `ENABLED` reader - 0=disabled: pump output is VDDA_PUMP, 1=enabled: pump output is boosted."]
pub struct ENABLED_R(crate::FieldReader<bool, bool>);
impl ENABLED_R {
    pub(crate) fn new(bits: bool) -> Self {
        ENABLED_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ENABLED_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `ENABLED` writer - 0=disabled: pump output is VDDA_PUMP, 1=enabled: pump output is boosted."]
pub struct ENABLED_W<'a> {
    w: &'a mut W,
}
impl<'a> ENABLED_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 31)) | ((value as u32 & 0x01) << 31);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Clock select: 0=external clock, 1=internal clock (deprecated)."]
    #[inline(always)]
    pub fn clock_sel(&self) -> CLOCK_SEL_R {
        CLOCK_SEL_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 31 - 0=disabled: pump output is VDDA_PUMP, 1=enabled: pump output is boosted."]
    #[inline(always)]
    pub fn enabled(&self) -> ENABLED_R {
        ENABLED_R::new(((self.bits >> 31) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Clock select: 0=external clock, 1=internal clock (deprecated)."]
    #[inline(always)]
    pub fn clock_sel(&mut self) -> CLOCK_SEL_W {
        CLOCK_SEL_W { w: self }
    }
    #[doc = "Bit 31 - 0=disabled: pump output is VDDA_PUMP, 1=enabled: pump output is boosted."]
    #[inline(always)]
    pub fn enabled(&mut self) -> ENABLED_W {
        ENABLED_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Switch pump control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pump_ctrl](index.html) module"]
pub struct PUMP_CTRL_SPEC;
impl crate::RegisterSpec for PUMP_CTRL_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [pump_ctrl::R](R) reader structure"]
impl crate::Readable for PUMP_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pump_ctrl::W](W) writer structure"]
impl crate::Writable for PUMP_CTRL_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PUMP_CTRL to value 0"]
impl crate::Resettable for PUMP_CTRL_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
